'===  Class Name:   frmWatch =============================================
'    Description:   FileWatch utility main form
'   Date Created:   2003.10.01
'	Code Copyright  2003 by Stan Schultes, All Rights Reserved.
'
'      Revision History
'   Who     Date		CodeVersion - Comments
'
'   Discussion:
'- This utility was written for Visual Studio Magazine, Feb 2004 Getting Started column.
'   It demonstrates a number of WinForms features including NotifyIcon, ToolTip,
'   FileSystemWatcher, ContextMenu and .NET drag and drop.
'- You point FileWatch to a file, a set of files matching a pattern, or a whole 
'   directory structure for changes. It minimizes to the task tray area of the Taskbar, 
'   and you control it through a right-click context menu on the tray icon. The tray icon
'   shows as white while idle, green while monitoring, and red when changes are detected.
'
'==========================================================================

Imports System.IO   'for File, Directory, Path objects
Public Class frmWatch
    Inherits System.Windows.Forms.Form

#Region " Form Declarations "

    Private Enum MonitorState
        msStartup
        msNotMonitoring
        msMonitoring
        msFileChanged
    End Enum

#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents grpMonitor As System.Windows.Forms.GroupBox
    Friend WithEvents txtWatchPath As System.Windows.Forms.TextBox
    Friend WithEvents chkMonitorSubs As System.Windows.Forms.CheckBox
    Friend WithEvents btnBrowse As System.Windows.Forms.Button
    Friend WithEvents chkEnable As System.Windows.Forms.CheckBox
    Friend WithEvents btnOK As System.Windows.Forms.Button
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    Friend WithEvents FileSystemWatcher1 As System.IO.FileSystemWatcher
    Friend WithEvents StatusBar1 As System.Windows.Forms.StatusBar
    Friend WithEvents NotifyIcon1 As System.Windows.Forms.NotifyIcon
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents ContextMenu1 As System.Windows.Forms.ContextMenu
    Friend WithEvents ctxMonitor As System.Windows.Forms.MenuItem
    Friend WithEvents ctxReset As System.Windows.Forms.MenuItem
    Friend WithEvents ctxShowWindow As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem4 As System.Windows.Forms.MenuItem
    Friend WithEvents ctxExit As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmWatch))
        Me.grpMonitor = New System.Windows.Forms.GroupBox()
        Me.btnBrowse = New System.Windows.Forms.Button()
        Me.chkMonitorSubs = New System.Windows.Forms.CheckBox()
        Me.txtWatchPath = New System.Windows.Forms.TextBox()
        Me.chkEnable = New System.Windows.Forms.CheckBox()
        Me.btnOK = New System.Windows.Forms.Button()
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.FileSystemWatcher1 = New System.IO.FileSystemWatcher()
        Me.StatusBar1 = New System.Windows.Forms.StatusBar()
        Me.NotifyIcon1 = New System.Windows.Forms.NotifyIcon(Me.components)
        Me.ContextMenu1 = New System.Windows.Forms.ContextMenu()
        Me.ctxMonitor = New System.Windows.Forms.MenuItem()
        Me.ctxReset = New System.Windows.Forms.MenuItem()
        Me.ctxShowWindow = New System.Windows.Forms.MenuItem()
        Me.MenuItem4 = New System.Windows.Forms.MenuItem()
        Me.ctxExit = New System.Windows.Forms.MenuItem()
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.grpMonitor.SuspendLayout()
        CType(Me.FileSystemWatcher1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'grpMonitor
        '
        Me.grpMonitor.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnBrowse, Me.chkMonitorSubs, Me.txtWatchPath})
        Me.grpMonitor.Location = New System.Drawing.Point(8, 16)
        Me.grpMonitor.Name = "grpMonitor"
        Me.grpMonitor.Size = New System.Drawing.Size(416, 104)
        Me.grpMonitor.TabIndex = 0
        Me.grpMonitor.TabStop = False
        Me.grpMonitor.Text = "Select a file with Browse  or type a directory name to monitor for changes"
        '
        'btnBrowse
        '
        Me.btnBrowse.Location = New System.Drawing.Point(320, 64)
        Me.btnBrowse.Name = "btnBrowse"
        Me.btnBrowse.TabIndex = 2
        Me.btnBrowse.Text = "Browse"
        Me.ToolTip1.SetToolTip(Me.btnBrowse, "Click to browse for a filename to monitor")
        '
        'chkMonitorSubs
        '
        Me.chkMonitorSubs.Location = New System.Drawing.Point(56, 64)
        Me.chkMonitorSubs.Name = "chkMonitorSubs"
        Me.chkMonitorSubs.Size = New System.Drawing.Size(184, 24)
        Me.chkMonitorSubs.TabIndex = 1
        Me.chkMonitorSubs.Text = "Monitor Subdirectories"
        Me.ToolTip1.SetToolTip(Me.chkMonitorSubs, "Use this option to monitor all subdirectories below your target directory")
        '
        'txtWatchPath
        '
        Me.txtWatchPath.AllowDrop = True
        Me.txtWatchPath.Location = New System.Drawing.Point(16, 32)
        Me.txtWatchPath.Name = "txtWatchPath"
        Me.txtWatchPath.Size = New System.Drawing.Size(384, 20)
        Me.txtWatchPath.TabIndex = 0
        Me.txtWatchPath.Text = ""
        Me.ToolTip1.SetToolTip(Me.txtWatchPath, "You can drag a filename here from Windows Explorer")
        '
        'chkEnable
        '
        Me.chkEnable.Location = New System.Drawing.Point(64, 128)
        Me.chkEnable.Name = "chkEnable"
        Me.chkEnable.Size = New System.Drawing.Size(120, 24)
        Me.chkEnable.TabIndex = 1
        Me.chkEnable.Text = "Enable Monitoring"
        Me.ToolTip1.SetToolTip(Me.chkEnable, "Click to start monitoring your chosen filename")
        '
        'btnOK
        '
        Me.btnOK.Location = New System.Drawing.Point(328, 128)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.TabIndex = 2
        Me.btnOK.Text = "OK"
        Me.ToolTip1.SetToolTip(Me.btnOK, "Click to send the form to the tray area of the taskbar")
        '
        'FileSystemWatcher1
        '
        Me.FileSystemWatcher1.EnableRaisingEvents = True
        Me.FileSystemWatcher1.SynchronizingObject = Me
        '
        'StatusBar1
        '
        Me.StatusBar1.Location = New System.Drawing.Point(0, 160)
        Me.StatusBar1.Name = "StatusBar1"
        Me.StatusBar1.Size = New System.Drawing.Size(432, 22)
        Me.StatusBar1.SizingGrip = False
        Me.StatusBar1.TabIndex = 3
        Me.StatusBar1.Text = "Enter a filename, set options, and click Enable Monitoring to begin"
        '
        'NotifyIcon1
        '
        Me.NotifyIcon1.ContextMenu = Me.ContextMenu1
        Me.NotifyIcon1.Text = "NotifyIcon1"
        Me.NotifyIcon1.Visible = True
        '
        'ContextMenu1
        '
        Me.ContextMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.ctxMonitor, Me.ctxReset, Me.ctxShowWindow, Me.MenuItem4, Me.ctxExit})
        '
        'ctxMonitor
        '
        Me.ctxMonitor.Index = 0
        Me.ctxMonitor.Text = "&Monitor"
        '
        'ctxReset
        '
        Me.ctxReset.Index = 1
        Me.ctxReset.Text = "&Reset"
        '
        'ctxShowWindow
        '
        Me.ctxShowWindow.Index = 2
        Me.ctxShowWindow.Text = "&Show Window"
        '
        'MenuItem4
        '
        Me.MenuItem4.Index = 3
        Me.MenuItem4.Text = "-"
        '
        'ctxExit
        '
        Me.ctxExit.Index = 4
        Me.ctxExit.Text = "E&xit"
        '
        'ImageList1
        '
        Me.ImageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
        Me.ImageList1.ImageSize = New System.Drawing.Size(16, 16)
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        '
        'frmWatch
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(432, 182)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.StatusBar1, Me.btnOK, Me.chkEnable, Me.grpMonitor})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "frmWatch"
        Me.ShowInTaskbar = False
        Me.Text = "FileWatch Utility"
        Me.ToolTip1.SetToolTip(Me, "The FileWatch utility is used to monitor files or directories for changes. Choose" & _
        " a file, a file pattern, or a directory to monitor and click the Enable checkbox" & _
        ".")
        Me.grpMonitor.ResumeLayout(False)
        CType(Me.FileSystemWatcher1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region " Form Event Routines "

    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        'set defaults if a path or filespec is already present
        If File.Exists(txtWatchPath.Text) Then
            OpenFileDialog1.FileName = txtWatchPath.Text            'it's a file
        ElseIf Directory.Exists(txtWatchPath.Text) Then
            OpenFileDialog1.InitialDirectory = txtWatchPath.Text    'it's a path
        ElseIf txtWatchPath.Text.Trim.Length > 0 AndAlso _
            Directory.Exists(Path.GetDirectoryName(txtWatchPath.Text)) Then
            'if the next directory up is valid, assume...
            OpenFileDialog1.InitialDirectory = txtWatchPath.Text    'it's a filespec
        End If
        OpenFileDialog1.CheckFileExists = True
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            If OpenFileDialog1.FileName.Length > 0 Then
                txtWatchPath.Text = OpenFileDialog1.FileName
                ToolTip1.SetToolTip(txtWatchPath, txtWatchPath.Text)
            End If
        End If
    End Sub

    'OK button sends the app to the task tray
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.WindowState = FormWindowState.Minimized
    End Sub

    'start and stop file monitoring
    Private Sub chkEnable_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkEnable.CheckedChanged
        If CType(sender, CheckBox).Checked Then
            StartMonitor()
        Else
            StopMonitor()
        End If
    End Sub

    'Monitor context menu item on tray icon
    Private Sub ctxMonitor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ctxMonitor.Click
        ToggleMonitor()
    End Sub

    'Reset context menu item on tray icon
    Private Sub ctxReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ctxReset.Click
        If ctxMonitor.Checked Then SetNotifyIcon(MonitorState.msMonitoring, "Monitoring...")
    End Sub

    'Show Window context menu item on tray icon
    Private Sub ctxShowWindow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ctxShowWindow.Click
        Me.WindowState = FormWindowState.Normal
    End Sub

    'Exit context menu item on tray icon
    Private Sub ctxExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ctxExit.Click
        Me.Close()
    End Sub

    'frmWatch Load event - initialize the utility
    Private Sub frmWatch_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetNotifyIcon(MonitorState.msNotMonitoring, "Monitoring Disabled")
    End Sub

    'event handler for FSW Changed,Created,Deleted events
    Private Sub fsw_Events(ByVal sender As System.Object, ByVal e As System.IO.FileSystemEventArgs) Handles FileSystemWatcher1.Changed, FileSystemWatcher1.Created, FileSystemWatcher1.Deleted
        Dim sChange As String
        Select Case e.ChangeType
            Case WatcherChangeTypes.Changed
                sChange = "File Changed: " & e.FullPath
            Case WatcherChangeTypes.Created
                sChange = "File Created: " & e.FullPath
            Case WatcherChangeTypes.Deleted
                sChange = "File Deleted: " & e.FullPath
        End Select
        Beep()
        SetNotifyIcon(MonitorState.msFileChanged, sChange)
    End Sub

    'event handler for FSW Renamed event
    Private Sub fsw_Renamed(ByVal sender As System.Object, ByVal e As System.IO.RenamedEventArgs) Handles FileSystemWatcher1.Renamed
        Dim sChange = "File Renamed: " & e.FullPath
        Beep()
        SetNotifyIcon(MonitorState.msFileChanged, sChange)
    End Sub

    'double-click event routine for tray icon
    Private Sub NotifyIcon1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles NotifyIcon1.DoubleClick
        ToggleMonitor()
    End Sub

    'drag and drop event routines
    Private Sub txtWatchPath_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtWatchPath.DragDrop
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim sFiles() As String = e.Data.GetData(DataFormats.FileDrop)
            'uncomment this code to see which files are dropped
            'Dim sFile As String, sDebug As String
            'For Each sFile In sFiles
            '    sDebug = sDebug & sFile & ","
            'Next
            'Debug.WriteLine("Received files: " & sDebug)
            txtWatchPath.Text = sFiles(0)       'take first file or directory dropped
        End If
    End Sub

    Private Sub txtWatchPath_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles txtWatchPath.DragEnter
        'uncomment this code to see which data formats are received from drop sources
        'Dim sDebug As String, sFormat As String
        'For Each sFormat In e.Data.GetFormats
        '    sDebug = sDebug & sFormat & ","
        'Next
        'Debug.WriteLine("Received formats: " & sDebug)
        e.Effect = DragDropEffects.All
    End Sub

    'TextBox change event handler - update ToolTip
    Private Sub txtWatchPath_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtWatchPath.TextChanged
        'reset the ToolTip as TextBox contents change
        If txtWatchPath.Text.Trim.Length > 0 Then
            ToolTip1.SetToolTip(txtWatchPath, txtWatchPath.Text)
        Else
            ToolTip1.SetToolTip(txtWatchPath, "You can drag a filename here from Windows Explorer")
        End If
    End Sub

#End Region

#Region " Form Private Methods "

    'set the tray icon's icon and text properties, and the form status bar
    Private Sub SetNotifyIcon(ByVal CurrentState As MonitorState, ByVal Text As String)
        Static LastMonitorState As MonitorState = MonitorState.msStartup
        If CurrentState <> LastMonitorState Then
            LastMonitorState = CurrentState
            Select Case CurrentState
                Case MonitorState.msNotMonitoring
                    Dim bm As System.Drawing.Bitmap = ImageList1.Images(0)
                    NotifyIcon1.Icon = Icon.FromHandle(bm.GetHicon())
                Case MonitorState.msMonitoring
                    Dim bm As System.Drawing.Bitmap = ImageList1.Images(1)
                    NotifyIcon1.Icon = Icon.FromHandle(bm.GetHicon())
                Case MonitorState.msFileChanged
                    Dim bm As System.Drawing.Bitmap = ImageList1.Images(2)
                    NotifyIcon1.Icon = Icon.FromHandle(bm.GetHicon())
            End Select
        End If
        NotifyIcon1.Text = Text
        StatusBar1.Text = Text
    End Sub

    'routine that starts file monitoring
    Private Sub StartMonitor()
        'determine what's in txtWatchPath: directory or filespec
        If Directory.Exists(txtWatchPath.Text) Then
            'its a directory
            FileSystemWatcher1.Path = txtWatchPath.Text
            FileSystemWatcher1.Filter = String.Empty   'all files
        ElseIf txtWatchPath.Text.Trim.Length > 0 AndAlso Directory.Exists(Path.GetDirectoryName(txtWatchPath.Text)) Then
            'its a filespec
            FileSystemWatcher1.Path = Path.GetDirectoryName(txtWatchPath.Text)
            FileSystemWatcher1.Filter = Path.GetFileName(txtWatchPath.Text)
        Else
            'not a valid path?
            StatusBar1.Text = "A valid path wasn't specified..."
            Exit Sub
        End If
        FileSystemWatcher1.IncludeSubdirectories = chkMonitorSubs.Checked
        'don't allow config changes once monitoring starts
        grpMonitor.Enabled = False
        'maintain checkbox and menu state on the form
        chkEnable.Checked = True
        ctxMonitor.Checked = True
        'start monitoring
        FileSystemWatcher1.NotifyFilter = (NotifyFilters.CreationTime Or _
            NotifyFilters.LastWrite Or NotifyFilters.FileName Or NotifyFilters.DirectoryName)
        SetNotifyIcon(MonitorState.msMonitoring, "Monitoring...")
        FileSystemWatcher1.EnableRaisingEvents = True
    End Sub

    'routine that stops file monitoring
    Private Sub StopMonitor()
        SetNotifyIcon(MonitorState.msNotMonitoring, "Monitoring Disabled")
        FileSystemWatcher1.EnableRaisingEvents = False
        'maintain checkbox and menu state on the form
        chkEnable.Checked = False
        ctxMonitor.Checked = False
        're-enable changes when not monitoring
        grpMonitor.Enabled = True
    End Sub

    'routine that toggles the file monitoring function on/off
    Private Sub ToggleMonitor()
        If ctxMonitor.Checked Then
            ctxMonitor.Checked = False
            StopMonitor()
        Else
            ctxMonitor.Checked = True
            StartMonitor()
        End If
    End Sub

#End Region

End Class
